#---
# Excerpted from "Genetic Algorithms in Elixir",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/smgaelixir for more book information.
#---
defmodule Types.Chromosome do

  @type t :: %__MODULE__{
    genes: Enum.t,
    size: integer(),
    fitness: number(),
    age: integer()
  }

  @enforce_keys :genes
  defstruct [:genes, id: Base.encode16(:crypto.strong_rand_bytes(64)), size: 0, fitness: 0, age: 0]

  defimpl String.Chars, for: __MODULE__ do
  	def to_string(c), do: c.id
  end
end