#---
# Excerpted from "Genetic Algorithms in Elixir",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/smgaelixir for more book information.
#---
defmodule Utilities.Statistics do
  use GenServer

  def init(opts) do
    :ets.new(:statistics, [:set, :public, :named_table])
    {:ok, opts}
  end

  def start_link(opts) do
    GenServer.start_link(__MODULE__, opts)
  end

  def insert(generation, statistics) do
    :ets.insert(:statistics, {generation, statistics})
  end

  def lookup(generation) do
    hd(:ets.lookup(:statistics, generation))
  end
end
